diff -Nru evince-2.30.3/debian/changelog evince-2.30.3/debian/changelog
--- evince-2.30.3/debian/changelog	2011-02-16 21:23:44.000000000 +0000
+++ evince-2.30.3/debian/changelog	2011-06-29 22:33:26.000000000 +0100
@@ -1,3 +1,12 @@
+evince (2.30.3-3.1) unstable; urgency=medium
+
+  * Non-maintainer upload.
+  * debian/patches/03_CVE-2011-0433.patch:
+    - fix CVE-2011-0433, a buffer overflow in token() in afmparse.c
+    Closes: #614668
+
+ -- Jonathan Wiltshire <jmw@debian.org>  Wed, 29 Jun 2011 22:19:33 +0100
+
 evince (2.30.3-3) unstable; urgency=low
 
   [ Josselin Mouette ]
diff -Nru evince-2.30.3/debian/patches/03_CVE-2011-0433.patch evince-2.30.3/debian/patches/03_CVE-2011-0433.patch
--- evince-2.30.3/debian/patches/03_CVE-2011-0433.patch	1970-01-01 01:00:00.000000000 +0100
+++ evince-2.30.3/debian/patches/03_CVE-2011-0433.patch	2011-06-29 22:33:26.000000000 +0100
@@ -0,0 +1,25 @@
+From: Vincent Untz <vuntz@gnome.org>
+Date: Thu, 17 Feb 2011 15:23:39 +0100
+Subject: [PATCH] backends: Fix another security issue in the dvi-backend
+Bug: https://bugzilla.gnome.org/show_bug.cgi?id=640923
+Bug-Debian: http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=614668
+
+This is similar to one of the fixes from d4139205.
+
+https://bugzilla.gnome.org/show_bug.cgi?id=640923
+---
+ backend/dvi/mdvi-lib/afmparse.c |    2 +-
+ 1 files changed, 1 insertions(+), 1 deletions(-)
+
+
+--- evince-2.30.3.orig/backend/dvi/mdvi-lib/afmparse.c
++++ evince-2.30.3/backend/dvi/mdvi-lib/afmparse.c
+@@ -190,7 +190,7 @@
+     while ((ch = fgetc(stream)) == ' ' || ch == '\t' ); 
+     
+     idx = 0;
+-    while (ch != EOF && ch != lineterm) 
++    while (ch != EOF && ch != lineterm && idx < MAX_NAME)
+     {
+         ident[idx++] = ch;
+         ch = fgetc(stream);
diff -Nru evince-2.30.3/debian/patches/series evince-2.30.3/debian/patches/series
--- evince-2.30.3/debian/patches/series	2011-02-16 21:23:44.000000000 +0000
+++ evince-2.30.3/debian/patches/series	2011-06-29 22:33:26.000000000 +0100
@@ -1,2 +1,3 @@
 01_dvi_security.patch
 02_link_ice.patch
+03_CVE-2011-0433.patch
